//============================================================================
//	aisa45w.pas
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.00 Date 1998/11/09
//
//============================================================================

unit aisa45w;

interface

uses
	Windows;

//-------------------------------------
// װޒ萔
//-------------------------------------
const
	AISA45_SUCCESS				      = 0;		// I
	AISA45_ERR_SYSTEM			      = 5001;	// GetLastError sĂ
	AISA45_ERR_NO_DEVICE		    = 5002;	// gp\޲Ȃ
	AISA45_ERR_IN_USE			      = 5003;	// w肳ꂽ޲͎gp
	AISA45_ERR_INVALID_SLOT		  = 5004;	// Ș_ۯĔԍw肵
	AISA45_ERR_RESOURCE			    = 5005;	// ؿװ
	AISA45_ERR_NO_CREATE				= 5006;	// ޲شĂĂ܂
	AISA45_ERR_INVALID_ARGUMENT = 5007;	// sȈv܂
	AISA45_ERR_INVALID_COMMAND  = 5051;	// sȃR}hv
	AISA45_ERR_INVALID_MODE     = 5052;	// sȃ[hw肵
	AISA45_ERR_CHANNEL          = 5053;	// `lݒ肪sł
	AISA45_ERR_TIMER            = 5054;	// ^C}lsł
	AISA45_ERR_BUFFSIZE         = 5055;	// obt@TCYsł
	AISA45_ERR_NOT_ENOUGH_MEM   = 5056;	// \ȃmۏo܂ł
	AISA45_ERR_NUMDATA          = 5057;	// w肳ꂽ̃f[^obt@ɑ݂܂
	AISA45_ERR_BUSY             = 5058;	// hCo̓rW[Ԃł
	AISA45_ERR_WRAPDLL 					= DWord(-1);		// ׯ߰֐װ
//-------------------------------------
// үID
//-------------------------------------
	WM_EOC							= 0;
	WM_BUFF_HALF_FULL		= 1;
	WM_BUFF_FULL				= 2;
	WM_BUFF_OVERFLOW		= 3;
	WM_SAMPLING_OVERRUN	= 4;
//-------------------------------------
// ݸޏԂ̒萔
//-------------------------------------
  AISA45_STS_SAMPLING         = $01;
  AISA45_STS_EOC              = $02;
  AISA45_STS_BUFF_HALF_FULL   = $04;
  AISA45_STS_BUFF_FULL        = $08;
  AISA45_STS_BUFF_OVERFLOW    = $10;
  AISA45_STS_SAMPLING_OVERRUN = $20;
//-------------------------------------
// ̑萔
//-------------------------------------
	AISA45_DLL_NAME 	= 'aisa45.dll';	// DLĻٖ
	AISA45_MAX_SLOTS	= 16;						// őۯĐ
	AISA45_DEVICE_ID	= $00000045;		// ޲ID
	AISA45_SLOT_AUTO	= $ffff;				// AutoSlotl
//-------------------------------------
// ؿ\
//-------------------------------------
	AISA45_MAX_MEM	=	 9;
	AISA45_MAX_IO		= 20;
	AISA45_MAX_IRQ	=	 7;
	AISA45_MAX_DMA	=	 7;

type
	TAISA45RESOURCE = record
		dwNumMemWindows:																DWORD;	// س޳(gp)
		dwMemBase:			array [1 .. AISA45_MAX_MEM] of	DWORD;	// س޳ްڽ(gp)
		dwMemLength:		array [1 .. AISA45_MAX_MEM] of	DWORD;	// س޳(gp)
		dwMemAttrib:		array [1 .. AISA45_MAX_MEM] of	DWORD;	// س޳(gp)
		dwNumIOPorts:																		DWORD;	// I/O߰Đ
		dwIOPortBase:		array [1 .. AISA45_MAX_IO] of		DWORD;	// I/O߰ްڽ
		dwIOPortLength: array [1 .. AISA45_MAX_IO] of		DWORD;	// I/O߰Ē
		dwNumIRQs:																			DWORD;	// IRQ(gp)
		dwIRQRegisters: array [1 .. AISA45_MAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwIRQAttrib:		array [1 .. AISA45_MAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwNumDMAs:																			DWORD;	// DMAِ(gp)
		dwDMALst:				array [1 .. AISA45_MAX_DMA] of	DWORD;	// DMAؽ(gp)
		dwDMAAttrib:		array [1 .. AISA45_MAX_DMA] of	DWORD;	// DMAّؽ(gp)
		dwReserved1:		array [1 .. 3] of								DWORD;	// \(gp)
	end;
//-------------------------------------
// ݸޓӰސݒ\
//-------------------------------------
type
	TAISA45MODE = record
		dwMode:   DWORD;									//샂[h (1 ` 2)
		dwChFirst:DWORD;									//ݸފJnفi0 ` 31)
		dwChLast: DWORD;									//ݸޏIفi0 ` 31)
		cwBuffer: DWORD;									//ޯ̧ށiܰޒP)
		dwTimer:  DWORD;									//ςɾĂli00H ` 3FH)
	end;
//-------------------------------------
// J֐
//-------------------------------------
// DLL ۰
function Aisa45wDllOpen: Boolean;
// DLL ۰
function Aisa45wDllClose: Boolean;
// aISA-A45 DLL,޲ײްްޮݔԍ擾
function Aisa45wGetVersion(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean;
// CӂaISA-A45̎gp錾
function Aisa45wCreate(var pwLogSlot:WORD; hwnd:THandle; uWMBase:UINT): Boolean;// CӂaISA-A45̎gpJ
// Cӂ޲̎gpJ
function Aisa45wClose(wLogSlot:WORD): Boolean;
// ؿ擾
function Aisa45wGetResource(wLogSlot:WORD; var pResInfo:TAISA45RESOURCE): Boolean;
// ݸޓӰސݒ
function Aisa45wSetMode(wLogSlot:WORD; var pcmode:TAISA45MODE): Boolean;
// ݸފJn
function Aisa45wStartSampling(wLogSlot:WORD): Boolean;
// ݸޒ~
function Aisa45wStopSampling(wLogSlot:WORD): Boolean;
// ݸޏԎ擾
function Aisa45wGetSamplingStatus(wLogSlot:WORD; var pcwNumData:DWORD; var pdwStatus:DWORD): Boolean;
// ݸް擾
function Aisa45wGetData(wLogSlot:WORD; cwNumData:DWORD; var pwData:WORD): BOOL;
// Cӂ߰Ăް
function Aisa45wInPort(wLogSlot:WORD; var pbInValue:BYTE): Boolean;
// aISA-A45̴װ
function Aisa45wGetLastError(wLogSlot:WORD): DWORD;
//-------------------------------------
// (STATIC)ϐȂ
//-------------------------------------
implementation

{$J+}	// ^t萔̕ύX\߲׎w
const
	hDLL: THandle = 0;

type
	TAisa45GetVersion = function(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): BOOL; stdcall;
	TAisa45Create = function(var pwLogSlot:WORD; hwnd:THandle; uWMBase:UINT): BOOL; stdcall;
	TAisa45Close = function(wLogSlot:WORD): BOOL; stdcall;
	TAisa45GetResource = function(wLogSlot:WORD; var pres:TAISA45RESOURCE): BOOL; stdcall;
	TAisa45SetMode = function(wLogSlot:WORD; var pcmode:TAISA45MODE): BOOL; stdcall;
	TAisa45StartSampling = function(wLogSlot:WORD): BOOL; stdcall;
	TAisa45StopSampling = function(wLogSlot:WORD): BOOL; stdcall;
	TAisa45GetSamplingStatus = function(wLogSlot:WORD; var pcwNumData:DWORD; var pdwStatus: DWORD): BOOL; stdcall;
	TAisa45GetData = function(wLogSlot:WORD; cwNumData:DWORD; var pwData:WORD): BOOL; stdcall;
	TAisa45InPort = function(wLogSlot:WORD; var pbInValue:BYTE): BOOL; stdcall;
	TAisa45GetLastError = function(wLogSlot:WORD): DWORD; stdcall;

// DLL ߰Ċ֐ڽ̊i[ϐ
var
	pAisa45GetVersion: TAisa45GetVersion;
	pAisa45Create: TAisa45Create;
	pAisa45Close: TAisa45Close;
	pAisa45GetResource: TAisa45GetResource;
	pAisa45SetMode: TAisa45SetMode;
	pAisa45StartSampling: TAisa45StartSampling;
	pAisa45StopSampling: TAisa45StopSampling;
	pAisa45GetSamplingStatus: TAisa45GetSamplingStatus;
	pAisa45GetData: TAisa45GetData;
	pAisa45InPort: TAisa45InPort;
	pAisa45GetLastError: TAisa45GetLastError;

function Aisa45wGetDllExportFunc: Boolean; forward;

{$J-}

//============================================================================
// 		aisa45.dll۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Aisa45wDllOpen: Boolean;
begin
	Result := False;
	if hDLL = 0 then begin
		hDLL := LoadLibrary(AISA45_DLL_NAME);
		if hDLL <> 0 then begin
			Result := Aisa45wGetDllExportFunc;
			if Result <> True then
				Aisa45wDllClose;		// DLL֐擾ɎŝDLL۰
		end;
	end;
end;
//============================================================================
// 		aisa45.dll۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Aisa45wDllClose: Boolean;
begin
	Result := False;
	if hDLL <> 0 then begin
		Result := FreeLibrary(hDLL);
		if Result = True then begin
			hDLL := 0;
		end;
	end;
end;
//============================================================================
// 		aISA-A45 DLL,޲ײްްޮݔԍ擾
// 		pdwDllVersion			DLLްޮݔԍi[̈ւ߲
//				pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Aisa45wGetVersion(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean;
begin
	Result := pAisa45GetVersion(pdwDllVersion, pdwDriverVersion)
end;
//============================================================================
// 		aISA-A45̔Cӂ޲̎gp錾
// 		pwLogSlot	 gp޲̘_ۯĔԍi[߲
//				hwnd			 ײނoүނ󂯎鳲޳
//				uWMBase		 oү ID
// ߂l  True
//				s False
//============================================================================
function Aisa45wCreate(var pwLogSlot:WORD; hwnd:THandle; uWMBase:UINT): Boolean;
begin
	Result := pAisa45Create(pwLogSlot, hwnd, uWMBase)
end;
//============================================================================
// 		aISA-A45̔Cӂ޲̎gpJ
// 		wLogSlot ޲̘_ۯĔԍ
// ߂l  True
//				s False
//============================================================================
function Aisa45wClose(wLogSlot:WORD): Boolean;
begin
	Result := pAisa45Close(wLogSlot)
end;
//============================================================================
// 		w޲ؿ擾
// 		wLogSlot	ؿ擾޲̘_ۯĔԍ
//				pResInfo	ؿi[\߲̂
// ߂l  True
//				s False
//============================================================================
function Aisa45wGetResource(wLogSlot:WORD; var pResInfo:TAISA45RESOURCE): Boolean;
begin
	Result := pAisa45GetResource(wLogSlot, pResInfo)
end;
//============================================================================
// 		ݸޓӰސݒ
// 		wLogSlot	ݸޓӰނݒ肷޲̘_ۯĔԍ
//				pcmode@	ݸޓӰނi[\߲̂
// ߂l  True
//				s False
//============================================================================
function Aisa45wSetMode(wLogSlot:WORD; var pcmode:TAISA45MODE): Boolean;
begin
	Result := pAisa45SetMode(wLogSlot, pcmode)
end;
//============================================================================
// 		ݸފJn
// 		wLogSlot	ݸފJn޲̘_ۯĔԍ
// ߂l  True
//				s False
//============================================================================
function Aisa45wStartSampling(wLogSlot:WORD): Boolean;
begin
	Result := pAisa45StartSampling(wLogSlot)
end;
//============================================================================
// 		ݸޒ~
// 		wLogSlot	ݸޒ~޲̘_ۯĔԍ
// ߂l  True
//				s False
//============================================================================
function Aisa45wStopSampling(wLogSlot:WORD): Boolean;
begin
	Result := pAisa45StopSampling(wLogSlot)
end;
//============================================================================
// 		ݸޏԎ擾
// 		wLogSlot		ݸޏԂ擾޲̘_ۯĔԍ
//				pcwNumData@ݸލςްi[̈ւ߲
//				pdwStatus		ݸޏԂ̽ði[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Aisa45wGetSamplingStatus(wLogSlot:WORD; var pcwNumData:DWORD; var pdwStatus:DWORD): Boolean;
begin
	Result := pAisa45GetSamplingStatus(wLogSlot, pcwNumData, pdwStatus)
end;
//============================================================================
// 		ݸް擾
// 		wLogSlot		ݸް擾޲̘_ۯĔԍ
// 				cwNumData		ǂݏoݸް
//				pwData			ݸްi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Aisa45wGetData(wLogSlot:WORD; cwNumData:DWORD; var pwData:WORD): BOOL;
begin
	Result := pAisa45GetData(wLogSlot, cwNumData, pwData)
end;
//============================================================================
// 		Cӂ߰Ăް
// 		wLogSlot	͂޲̘_ۯĔԍ
//				pbInValue ްi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Aisa45wInPort(wLogSlot:WORD; var pbInValue:BYTE): Boolean;
begin
	Result := pAisa45InPort(wLogSlot, pbInValue)
end;
//============================================================================
// 		aISA-A45̴װ
// 		wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//============================================================================
function Aisa45wGetLastError(wLogSlot:WORD): DWORD;
begin
	if hDLL = 0 then Result := AISA45_ERR_WRAPDLL
	else Result := pAisa45GetLastError(wLogSlot)
end;
//---------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  True
//		  	s False
//---------------------------------------------------------------------------
function Aisa45wGetDllExportFunc: Boolean;
begin
	Result := False;
	// Aisa45GetVersion ̱ڽ擾
	pAisa45GetVersion := GetProcAddress(hDLL, 'Aisa45GetVersion');
	if @pAisa45GetVersion = nil then Exit;
	// Aisa45Create ̱ڽ擾
	pAisa45Create := GetProcAddress(hDLL, 'Aisa45Create');
	if @pAisa45Create = nil then Exit;
	// Aisa45Close ̱ڽ擾
	pAisa45Close := GetProcAddress(hDLL, 'Aisa45Close');
	if @pAisa45Close = nil then Exit;
	// Aisa45GetResource ̱ڽ擾
	pAisa45GetResource := GetProcAddress(hDLL, 'Aisa45GetResource');
	if @pAisa45GetResource = nil then Exit;
	// Aisa45SetMode ̱ڽ擾
	pAisa45SetMode := GetProcAddress(hDLL, 'Aisa45SetMode');
	if @pAisa45SetMode = nil then Exit;
	// Aisa45StartSampling ̱ڽ擾
	pAisa45StartSampling := GetProcAddress(hDLL, 'Aisa45StartSampling');
	if @pAisa45StartSampling = nil then Exit;
	// Aisa45StopSampling ̱ڽ擾
	pAisa45StopSampling := GetProcAddress(hDLL, 'Aisa45StopSampling');
	if @pAisa45StopSampling = nil then Exit;
	// Aisa45GetSamplingStatus ̱ڽ擾
	pAisa45GetSamplingStatus := GetProcAddress(hDLL, 'Aisa45GetSamplingStatus');
	if @pAisa45GetSamplingStatus = nil then Exit;
	// Aisa45GetData ̱ڽ擾
	pAisa45GetData := GetProcAddress(hDLL, 'Aisa45GetData');
	if @pAisa45GetData = nil then Exit;
	// Aisa45InPort ̱ڽ擾
	pAisa45InPort := GetProcAddress(hDLL, 'Aisa45InPort');
	if @pAisa45InPort = nil then Exit;
	// Aisa45GetLastError ̱ڽ擾
	pAisa45GetLastError := GetProcAddress(hDLL, 'Aisa45GetLastError');
	if @pAisa45GetLastError = nil then Exit;
	// SĂ DLL ߰Ċ֐ڽ擾nj
	Result := True;
end;

end.

