Attribute VB_Name = "Wrapper"
'============================================================================
'   aisa45w.bas
'
'   Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'
'   V1.00 Date 1998/11/09
'
'============================================================================
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA45_DLL_NAME = "aisa45.dll" ' DLL
Global Const AISA45_ERR_WRAPDLL = -1        ' bp[֐G[

Dim hDLL As Long                'DLLւ

'============================================================================
'     aisa45.dll۰(۰ގʹװƂ)
'     
'  ߂l  True
'         s False
'============================================================================
Function Aisa45wDllOpen() As Boolean
  Aisa45wDllOpen = False
  If hDLL = 0 Then
    hDLL = LoadLibrary(AISA45_DLL_NAME)
    If hDLL <> 0 Then
      Aisa45wDllOpen = Aisa45wGetDllExportFunc()
      If Aisa45wDllOpen <> True Then
        Aisa45wDllClose    ' DLL֐擾ɎŝDLL۰
      End If
    End If
  End If
End Function
'============================================================================
'     aisa45.dll۰(۰ގʹװƂ)
'     
'  ߂l  True
'         s False
'============================================================================
Function Aisa45wDllClose() As Boolean
  Aisa45wDllClose = False
  If hDLL <> 0 Then
    If FreeLibrary(hDLL) <> 0 Then
      hDLL = 0
      Aisa45wDllClose = True
    End If
  End If
End Function
'============================================================================
'     aISA-A45 DLL,޲ײްްޮݔԍ擾
'     pdwDllVersion     DLLްޮݔԍi[̈ւ߲
'         pdwDriverVersion  ޲ײްްޮݔԍi[̈ւ߲
'  ߂l  True
'         s False
'============================================================================
Function Aisa45wGetVersion(pdwDllVersion As Long, pdwDriverVersion As Long) As Boolean
  If Aisa45GetVersion(pdwDllVersion, pdwDriverVersion) = 0 Then
    Aisa45wGetVersion = False
  Else
    Aisa45wGetVersion = True
  End If
End Function
'============================================================================
'     aISA-A45̔Cӂ޲̎gp錾
'     pwLogSlot  gp޲̘_ۯĔԍi[߲
'         hwnd       ײނoүނ󂯎鳲޳
'         uWMBase    oү ID
'  ߂l  True
'         s False
'============================================================================
Function Aisa45wCreate(pwLogSlot As Integer, ByVal hwnd As Long, ByVal uWMBase As Long) As Long
  If Aisa45Create(pwLogSlot, hwnd, uWMBase) = 0 Then
    Aisa45wCreate = False
  Else
    Aisa45wCreate = True
  End If
End Function
'============================================================================
'     aISA-A45̔Cӂ޲̎gpJ
'     wLogSlot ޲̘_ۯĔԍ
'  ߂l  True
'         s False
'============================================================================
Function Aisa45wClose(ByVal wLogSlot As Integer) As Boolean
  If Aisa45Close(wLogSlot) = 0 Then
    Aisa45wClose = False
  Else
    Aisa45wClose = True
  End If
End Function
'============================================================================
'     w޲ؿ擾
'     wLogSlot  ؿ擾޲̘_ۯĔԍ
'         pResInfo  ؿi[\߲̂
'  ߂l  True
'         s False
'============================================================================
Function Aisa45wGetResource(ByVal wLogSlot As Integer, pResInfo As AISA45RESOURCE) As Boolean
  If Aisa45GetResource(wLogSlot, pResInfo) = 0 Then
    Aisa45wGetResource = False
  Else
    Aisa45wGetResource = True
  End If
End Function
'============================================================================
'     ݸޓӰސݒ
'     wLogSlot  ݸޓӰނݒ肷޲̘_ۯĔԍ
'         pcmode@  ݸޓӰނi[\߲̂
'  ߂l  True
'         s False
'============================================================================
Function Aisa45wSetMode(ByVal wLogSlot As Integer, pcmode As AISA45MODE) As Long
  If Aisa45SetMode(wLogSlot, pcmode) = 0 Then
    Aisa45wSetMode = False
  Else
    Aisa45wSetMode = True
  End If
End Function
'============================================================================
'     ݸފJn
'     wLogSlot  ݸފJn޲̘_ۯĔԍ
'  ߂l  True
'         s False
'============================================================================
Function Aisa45wStartSampling(ByVal wLogSlot As Integer) As Long
  If Aisa45StartSampling(wLogSlot) = 0 Then
    Aisa45wStartSampling = False
  Else
    Aisa45wStartSampling = True
  End If
End Function
'============================================================================
'     ݸޒ~
'     wLogSlot  ݸޒ~޲̘_ۯĔԍ
'  ߂l  True
'         s False
'============================================================================
Function Aisa45wStopSampling(ByVal wLogSlot As Integer) As Long
  If Aisa45StopSampling(wLogSlot) = 0 Then
    Aisa45wStopSampling = False
  Else
    Aisa45wStopSampling = True
  End If
End Function
'============================================================================
'     ݸޏԎ擾
'     wLogSlot    ݸޏԂ擾޲̘_ۯĔԍ
'         pcwNumData@ݸލςްi[̈ւ߲
'         pdwStatus   ݸޏԂ̽ði[̈ւ߲
'  ߂l  True
'         s False
'============================================================================
Function Aisa45wGetSamplingStatus(ByVal wLogSlot As Integer, pcwNumData As Long, pdwStatus As Long) As Long
  If Aisa45GetSamplingStatus(wLogSlot, pcwNumData, pdwStatus) = 0 Then
    Aisa45wGetSamplingStatus = False
  Else
    Aisa45wGetSamplingStatus = True
  End If
End Function
'============================================================================
'     ݸް擾
'     wLogSlot    ݸް擾޲̘_ۯĔԍ
'         cwNumData   ǂݏoݸް
'         pwData      ݸްi[̈ւ߲
'  ߂l  True
'         s False
'============================================================================
Function Aisa45wGetData(ByVal wLogSlot As Integer, ByVal cwNumData As Long, pwData As Integer) As Long
  If Aisa45GetData(wLogSlot, cwNumData, pwData) = 0 Then
    Aisa45wGetData = False
  Else
    Aisa45wGetData = True
  End If
End Function
'============================================================================
'     Cӂ߰Ăް
'     wLogSlot  ͂޲̘_ۯĔԍ
'         pbInValue ްi[̈ւ߲
'  ߂l  True
'         s False
'============================================================================
Function Aisa45wInPort(ByVal wLogSlot As Integer, pbInValue As Byte) As Boolean
  If Aisa45InPort(wLogSlot, pbInValue) = 0 Then
    Aisa45wInPort = False
  Else
    Aisa45wInPort = True
  End If
End Function
'============================================================================
'     aISA-A45̴װ
'     wLogSlot  װ޲̘_ۯĔԍ
'  ߂l װ
'============================================================================
Function Aisa45wGetLastError(ByVal wLogSlot As Integer) As Long
  If hDLL = 0 Then
    Aisa45wGetLastError = AISA45_ERR_WRAPDLL
  Else
    Aisa45wGetLastError = Aisa45GetLastError(wLogSlot)
  End If
End Function
'---------------------------------------------------------------------------
'     DLL߰Ċ֐ڽ̎擾
'     
'  ߂l  True
'         s False
'---------------------------------------------------------------------------
Private Function Aisa45wGetDllExportFunc() As Boolean
  Dim pFunc As Long
  Aisa45wGetDllExportFunc = False
  ' Aisa45GetVersion ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa45GetVersion")
  If pFunc = 0 Then Exit Function
  ' Aisa45Create ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa45Create")
  If pFunc = 0 Then Exit Function
  ' Aisa45Close ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa45Close")
  If pFunc = 0 Then Exit Function
  ' Aisa45GetResource ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa45GetResource")
  If pFunc = 0 Then Exit Function
  ' Aisa45SetMode ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa45SetMode")
  If pFunc = 0 Then Exit Function
  ' Aisa45StartSampling ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa45StartSampling")
  If pFunc = 0 Then Exit Function
  ' Aisa45StopSampling ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa45StopSampling")
  If pFunc = 0 Then Exit Function
  ' Aisa45GetSamplingStatus ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa45GetSamplingStatus")
  If pFunc = 0 Then Exit Function
  ' Aisa45GetData ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa45GetData")
  If pFunc = 0 Then Exit Function
  ' Aisa45InPort ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa45InPort")
  If pFunc = 0 Then Exit Function
  ' Aisa45GetLastError ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa45GetLastError")
  If pFunc = 0 Then Exit Function
  ' SĂ DLL ߰Ċ֐ڽ擾
  Aisa45wGetDllExportFunc = True
End Function

